#!/usr/bin/env python
"""
  Otladka metodiki analiza NTFS etc.;
w dann. fajle - wspomog. podprogrammy.
  Ispolxz.:
- http://www.writeblocked.org/resources/ntfs_cheat_sheets.pdf
  -> ntfschea,pdf ;
- http://www.cse.scu.edu/~tschwarz/coen252_07Fall/Lectures/NTFS.html
  -> 152_NTFS.zip .
  Zame`.: wrode by w MBR dlq razdelow nomera sektorow 
sootw. numeracii ne ot 0, a ot 1 !
"""
from geral import file_stat,printable_s,dump_s,dump_s_,file_ari
import os,time,struct

def test_file_size(imq):
 siz,dat=file_stat('.',imq)
 n_sect=siz/512; ost=siz%512
 s='test_file_size: %s %d %d=0x%X %d' % (imq,siz,n_sect,n_sect,ost)
 if ost!=0: s+=' !!!'
 print s

s_err = chr(0x80)*512  # Predlag. pri o[ibke `teniq sektora wozwr. s_err .
whodn,ofs_sectors=None,None
imq_dann,imq_err=None,None

def set_whodn(whodn_,ofs_sectors_):
 """
 whodn_ - imq analiziruemogo ustr-wa ili fajla, 
          napr., '/dev/sdc' ili 'sdc.dat';
 ofs_sectors_ - sme]enie na`alxnogo sektora analiziruemoj oblasti, 
          napr., 0 dlq MBR.
 """
 global whodn,ofs_sectors
 print 'set_whodn: %s %X' % (repr(whodn_),ofs_sectors_)
 whodn = whodn_
 ofs_sectors = ofs_sectors_

def set_wyhodn(imq_dann_,imq_err_):
 global imq_dann,imq_err
 print 'set_wyhodn: %s %s' % (repr(imq_dann_),repr(imq_err_))
 imq_dann = imq_dann_
 imq_err = imq_err_

def read_sec(n, comment=None):
 """
 ~itaet sektor s zadannym sme]eniem;
 t.e. dlq 1-go sektora nado bratx n=0.
 """
 smesc=512*(ofs_sectors+n)
 if not comment:
  print 'read_sec: n,smesc=%08X %08X' % (n,smesc)
 else:
  print 'read_sec: n,smesc=%08X %08X / %s' % (n,smesc,comment)
 f0=open(whodn,'rb')
 f0.seek(smesc)
 gut=True
 try:
  s=f0.read(512)
 except:
  f2=open(imq_err,'ab')
  ss='read_sect: %X+%X=%X -> err.!' % (ofs_sectors,n,ofs_sectors+n)
  print ss
  f2.write(ss+'\n')
  f2.close()
  s=s_err
  gut=False
 return(s,gut)

def read_nesk_sect(n,n_sect=1, comment=None):
 smesc=512*(ofs_sectors+n)
 if not comment:
  print 'read_nesk_sect: n,smesc,n_sect=%08X %08X %d' % (n,smesc,n_sect)
 else:
  print 'read_nesk_sect: n,smesc,n_sect=%08X %08X %d / %s' % (n,smesc,n_sect,comment)
 f0=open(whodn,'rb')
 f0.seek(smesc)
 n_err=0
 try:
  s=f0.read(512*n_sect)
 except:
  s=''
  for i in range(n_sect):
   si,guti=read_sec(n+i)
   s+=si
   if not guti: n_err+=1
 try:
  assert len(s)==512*n_sect
 except:
  print 'read_nesk_sect: n_sect,len(s)= %d %d - ne pro`italosx !!!' % \
    (n_sect,len(s))
  raise
 return(s,n_err)

def read_clus(nr_clus):
 nr=8*nr_clus
 s,n_err=read_nesk_sect(nr,8, comment='cluster=0x%X' % (nr_clus,))
 return(s,n_err)

# --------

def write_sec_append(s):
 assert len(s)==512
 f1=open(imq_dann,'ab')
 f1.write(s)
 f1.close()

def write_xxx_append(s):
 """
 Bez prowerki dliny, napr., zapis. dannye iz 
 wosstanawliwaemogo fajla.
 """
 f1=open(imq_dann,'ab')
 f1.write(s)
 f1.close()

def zapis(s,imq, append=False):
 if not append: f1=open(imq,'wb')
 else: f1=open(imq,'ab')
 f1.write(s)
 f1.close()

def zapis_info(s):
 # print 'zapis_info:',repr(s)
 f2=open('tempor.htm','ab')
 f2.write(s+'\n')
 f2.close()

# --------

"""
Analiz MBR - iz  
https://habr.com/ru/post/347002/ .
"""

s0_16=chr(0)*16

def anal_opis_razdela_MBR(si):
 "si - opisanie razdela MBR dlinoj 16 bajt."
 print '-'*4
 assert len(si)==16
 if si==s0_16: print 'Nuli.'; return(None)
 s=''
 for x in si:
  ssi='%02X ' % (ord(x),)
  s+=ssi
 print s
 hh=struct.unpack('BBHBBHLL',si)
 # print hh
 prizn,h0,cs0,tip,h1,cs1,LBA_0,LBA_len=hh
 print 'prizn = %02X' % (prizn,)
 print 'tip = %02X' % (tip,)
 print 'h0,cs0,h1,cs1 =',h0,cs0,h1,cs1
 print 'LBA_0,LBA_len = 0x%X 0x%X=%3.1f Gb' % \
   (LBA_0,LBA_len,float(LBA_len)/1024/1024/1024*512)
 return(LBA_0,LBA_len)

def anal_MBR(imq, ofs_sec=0):
 f0=open(imq,'rb')
 f0.seek(512*ofs_sec)
 s=f0.read(512)
 f0.close()
 spisok=[]
 for i in range(4):
  adr=0x1BE+16*i
  si=s[adr:(adr+16)]
  resu = anal_opis_razdela_MBR(si)
  spisok.append(resu)
 return(spisok)

# --------

# Struktura opisanij fajlow - iz:
# - sohran@nnyh ntfs1.zip i ntfschea.pdf .
# - http://www.cse.scu.edu/~tschwarz/coen252_07Fall/Lectures/NTFS.html
#   -> 152_NTFS.zip .

sec_per_clust = None
ofs_MFT_clus = None

def anal_NTFS_header():
 global sec_per_clust,ofs_MFT_clus

 print '----- anal_NTFS_header -----\\'

 print 'Pered read_nesk_sect(0,n_sect=3).'
 s,n_err=read_nesk_sect(0,n_sect=3, comment="Ctenie NTFS-header'a.")
 print 'n_err,len(s)=',n_err,len(s)

 sec_per_clust=ord(s[0x0D])
 print 'sec_per_clust=',sec_per_clust
 specif='QQLL'
 hh = struct.unpack(specif,s[0x30:0x48])
 ofs_MFT_clus,ofs_MFTmirr_clus,clus_per_rec,clus_per_ind  = hh
 print 'ofs_MFT_clus= %016X' % (ofs_MFT_clus,)
 # print 'ofs_MFTmirr_clus= %016X' % (ofs_MFTmirr_clus,)
 # print 'clus_per_rec= %08X' % (clus_per_rec,)
 # print 'clus_per_ind= %08X' % (clus_per_ind,)
 print '=> na`alo MFT= %08X' % (sec_per_clust*ofs_MFT_clus,) 

 print '----- anal_NTFS_header -----/'

def read_MFT(i, otlad=False):
 """
 ~tenie i-go \lementa MFT.
 Posle `teniq predlag. assert n_err==0 i anal_opis_fajla(s,i).
 """
 print '----- read_MFT',i,'-----\\'
 nr_sec=sec_per_clust*ofs_MFT_clus+2*i
 s,n_err = read_nesk_sect(nr_sec,n_sect=2, comment='read_MFT('+str(i)+')')
 print 'read_MFT -> %04X %s' % (i,printable_s(s[:16]))
 try:
  assert s[:4]=='FILE'
 except:
  print 'read_MFT: s[...]=',repr(s[:16])
  raise
 if otlad:
  imq='mft%04X.dat' % (i,)
  zapis(s,imq)
 print '----- read_MFT',i,'-----/'
 return(s,n_err)

# --------

fajl_parame_list=['imena','len','date','dann','cepocki']
# dann - dlq rezid. fajlow, cepo`ki - dlq nerezid.
fajl_parame={'imena':[], 'len':None, 'date':None, 
  'dann':None, 'cepocki':None}

def fajl_parame_show():
 print '----- fajl_parame_show -----\\'
 for x in fajl_parame_list:
  print x,repr(fajl_parame[x])
  if x=='date':
   t_sec_1970 = t_NTFS_1970(fajl_parame[x])
   t = time.localtime(t_sec_1970)
   tim=(t.tm_year,t.tm_mon,t.tm_mday,t.tm_hour,t.tm_min,t.tm_sec)
   print 'date ->',tim
  osob = x=='cepocki' and fajl_parame[x]!=None
  if osob:
   xx=fajl_parame[x]
   yy=map(s_cepocka,xx)
   print 'cepocki ->',yy
 print '----- fajl_parame_show -----/'

def get_fajl_parame():
 return(fajl_parame)

def fajl_wossozd():
 print '----- fajl_wossozd -----\\'
 imena=fajl_parame['imena']
 if imena==[]:
  print 'fajl_wossozd: imq ots.; otkaz. ot popytki.' 
  return
 imq=''
 for imq_ in imena:
  if len(imq_)>len(imq): imq=imq_
 print 'fajl_wossozd: imq=',repr(imq)
 if imq in [u'.']:
  print 'fajl_wossozd: imq = "." ili analog.; otkaz. ot popytki.' 
  return
 if file_ari(imq): imq='tempor.dat'
 if fajl_parame['dann']==None and fajl_parame['cepocki']==None:
  print 'fajl_wossozd: i dann, i cepo`ki ==None;'
  print 'takoe m.b. dlq katalogow; otkazywaemsq ot popytki.'
  return
 if fajl_parame['cepocki']==None:
  dann=fajl_parame['dann']
  assert type(dann)==type('')
 else: 
  cepocki=fajl_parame['cepocki']
  dlina=fajl_parame['len']
  assert type(dlina)==type(0)
  dann=izwlek_iz_cepocek(cepocki,dlina)
 print 'fajl_wossozd: imq,len(dann)=',repr(imq),len(dann)
 f1=open(imq,'ab')
 f1.write(dann)
 f1.close()
 time_NTFS = fajl_parame['date'] 
 assert time_NTFS!=None
 ust_time(imq,time_NTFS)
 print '----- fajl_wossozd -----/'

def izwlek_iz_cepocek(cepocki,dlina_fajla):
 """
 cepo`ki - spisok \l-tow wida
 ('1', '\x05', '\x13\xf6\x03') -> '31/05/13F603';
 31 -> 1 i 3 = dliny sledu;]ih polej,  
 """
 ostalosx=dlina_fajla

 print 'ostalosx = dlina_fajla =',ostalosx

 nakoplen_dann=''
 nacalxn_klast=0
 for s1,s2,s3 in cepocki:
  n_klast=invert(s2) # ~islo klasterow w cepo`ke; w dann. primere - 05.
  delta=invert(s3)   # Sme]eniq; w dann. prim. - 03F613.
  print 'delta=%08X' % (delta,)
  nacalxn_klast+=delta
  print 'nacalxn_klast=%08X' % (nacalxn_klast,)

  for i in range(n_klast):
   nr_clus=nacalxn_klast+i
   s,n_err=read_clus(nr_clus)
   if ostalosx<len(s): s=s[:ostalosx]
   """
   # Bylo dlq otladki - zatykaem.
   if len(nakoplen_dann)>32*1024: 
    print 'izwlek_iz_cepocek: len>32 kb - ignoriruem !!!'
    continue
   """
   nakoplen_dann+=s
   ostalosx-=len(s)
   print 'izwlek_iz_cepocek:',len(nakoplen_dann),ostalosx
 return(nakoplen_dann)

def invert(s):
 """
 Dlq izwlek_iz_cepocek; '\x13\xf6\x03' -> 0x03F613 .
 Nado u`estx znak, napr., predp., `to \0xff\0xff\0xff -> -1,
 no poka `to neqsno, kogda nado i kogda net, 
 po\tomu poka `to \togo ne delaem.
 """
 n=0
 s2=s[::-1]
 for c in s2:
  n*=256
  n+=ord(c)
 print 'invert: %s -> %X' % (repr(s),n)
 return(n)

def anal_opis_fajla(s,nr, otlad=False):
 """
 s - pro`itannyj \lement MFT (dlina = 1024); 
 nr - nomer \togo \lementa.
 """
 global fajl_parame
 print '----- anal_opis_fajla',nr,'-----\\'
 print 'anal_opis_fajla: nr= %d = 0x%X' % (nr,nr)
 zapis_info('\n--------\nnr=%04X' % (nr,))
 fajl_parame={'imena':[], 'len':None, 'date':None, 
   'dann':None, 'cepocki':None}
 print 's[:4]=',repr(s[:4])
 sx=s[:0x30]
 sablon='4sHHQHHHHLLQHHL'  # 152_NTFS.zip, Table 3.
 hh=struct.unpack(sablon,sx)
 magic,ofs_upd,fixup,logf,seq_nr,linkcoun,firstattr,flags,siz1,siz2,\
   fileref,nextattr,align,nr_mft=hh
 if otlad:
  print '%04X ofs_upd' % (ofs_upd,)      # 4 2
  print '%04X fixup' % ( fixup,)         # 6 2
  print '%04X logf' % ( logf,)           # 8 8
  print '%04X seq_nr' % ( seq_nr,)       # 0x10 2
  print '%04X linkcoun' % ( linkcoun,)   # 0x12 2
  print '%04X firstattr' % ( firstattr,) # 0x14 2 ofs. of first attr.
  print '%04X flags' % ( flags,)         # 0x16 2 (1 - in use, 2 - dir)
  print '%04X siz1' % ( siz1,)           # 0x18 4
  print '%04X siz2' % ( siz2,)           # 0x1C 4
  print '%04X fileref' % ( fileref,)     # 0x20 8
  print '%04X nextattr' % ( nextattr,)   # 0x28 2
  print '%04X align' % ( align,)         # 0x2A 2
  print '%04X nr_mft' % ( nr_mft,)       # 0x2C 4
 zapis_info('flags=%s' % (bin(flags)[2:].zfill(8),))
 adr0 = firstattr
 while True:
  resu = anal_attrib(s,nr,adr0, otlad=otlad)
  if resu==None: break
  tip,dlina = resu
  print 'anal_attrib -> tip,dlina=%08X %08X' % (tip,dlina)
  adr1=adr0+dlina
  print 'anal_attrib -> adr1=%08X' % (adr1,)
  adr0=adr1
 print '----- anal_opis_fajla',nr,'-----/'

def anal_attrib(s,nr,ofs0, otlad=False):
 """
 s - opisanie fajla dliny 1 kb;
 nr - nomer \togo opisaniq w MFT;
 ofs0 - sme[. na`ala atributa.
 """
 print '----- anal_attrib nr='+str(nr)+' '+'ofs0=%08X' % (ofs0,)+' -----\\'
 assert len(s)==1024
 if otlad: print 'ofs0=%08X' % (ofs0,)
 tip = struct.unpack('L',s[ofs0:ofs0+4])[0]
 # Norm. priznak konca - tip==0xFFFFFFFF.
 gut = tip<=0x100 and tip%0x10==0
 if not gut:
  print 'tip= %08X - konec.' % (tip,)
  return(None)
 sablon='LLBBHHH'
 hh = struct.unpack(sablon,s[ofs0:ofs0+0x10])
 tip,dlina,nonres,len_nam,ofs_nam,flags,ident=hh
 if otlad:
  format='%08X..%08X %08X / %02X %02X %04X %04X / %02X'
  # print 'tip=%08X' % (tip,)
  # print 'dlina=%08X' % (dlina,)
  argt=(ofs0,ofs0+dlina,tip,nonres,len_nam,ofs_nam,flags,ident)
  sx = format % argt
  print 'ofs0..ofs1      tip    / nonres len_nam ofs_nam flags / ident'
  print sx
 zapis_info('tip,ident,nonres=%08X %d %d' % (tip,ident,nonres))
 if nonres==0:
  obrab_resident(s[ofs0:ofs0+dlina],nr, otlad=otlad)
 else:
  obrab_nonresident(s[ofs0:ofs0+dlina],nr, otlad=otlad)
 print '----- anal_attrib nr='+str(nr)+' '+'ofs0=%08X' % (ofs0,)+' -----/'
 return(tip,dlina)

def obrab_nonresident(attr,nr, otlad=False):
 print 'obrab_nonresident: anal_attr_name: nr,len(attr)=%04X %X' % \
   (nr,len(attr),)
 sablon='LLBBHHH' # 152_NTFS.zip, tabl. 5.
 hh = struct.unpack(sablon,attr[0:0x10])
 tip,dlina,nonres,len_nam,ofs_nam,flags,ident=hh
 sablon='QQHHLQQQ'  # 152_NTFS.zip, tabl. 5.
 gg = struct.unpack(sablon,attr[0x10:0x40])
 sta,end,ofs_rl,comp,u1,siz1,siz2,siz3=gg
 if otlad:
  print 'sta=%08X' % (sta,)
  print 'end=%08X' % (end,)
  print 'ofs_rl=%02X' % (ofs_rl,)
 sx = 'sizes= %08X %08X %08X' % (siz1,siz2,siz3)
 if otlad: print sx
 zapis_info(sx)
 if siz3!=siz2: print 'siz3!=siz2 !!!'
 fajl_parame['len']=siz3
 if tip==0x80:
  anal_runlist(attr[ofs_rl:],nr)

def obrab_resident(attr,nr, otlad=False):
 print 'obrab_resident: anal_attr_name: nr,len(attr)=%04X %X' % \
   (nr,len(attr),)
 sablon='LLBBHHH' # 152_NTFS.zip, tabl. 5.
 hh = struct.unpack(sablon,attr[0:0x10])
 tip,dlina,nonres,len_nam,ofs_nam,flags,ident=hh
 sablon='LHH' # 152_NTFS.zip, tabl. 5.
 gg = struct.unpack(sablon,attr[0x10:0x18])
 cont_siz,cont_ofs,x1=gg
 if otlad:
  print 'siz,ofs,x1= %04X %02X %02X' % (cont_siz,cont_ofs,x1)
 fajl_parame['len']=cont_siz
 content=attr[cont_ofs:cont_ofs+cont_siz]
 if tip==0x30:
  anal_attr_name_resid(content,nr)  
 if tip==0x80:
  if otlad: print repr(content[:40])
  zapis_info(repr(content[:40]))
  fajl_parame['dann']=content

def anal_attr_name_resid(content,nr):
 print 'anal_attr_name_resid: len(content)=%X' % (len(content),)
 sablon='QQQQQQQLHHBB'
 hh=struct.unpack(sablon,content[:0x42])
 parent,t1,t2,t3,t4,siz1,siz2,flags,x1,x2,len_nam,x3=hh
 # len_nam=ord(content[0x40])
 print 'parent=%08X' % (parent,)
 print 'siz1,siz2=%d %d' % (siz1,siz2)
 fajl_parame['date']=t2
 imq = content[0x42:0x42+len_nam*2]
 print 'len(imq)= %X = %d' % (len(imq),len(imq))
 imq_=''
 for i in range(len_nam):
  s=imq[(2*i):(2*i+2)]
  n=ord(s[1])*256+ord(s[0])
  c=unichr(n)
  imq_+=c
 sx='%04X %s' % (nr,repr(imq_))
 print sx
 zapis_info(sx)
 fajl_parame['imena'].append(imq_)

def s_cepocka(cepocka):
 c,len_,ofs_=cepocka
 sx = dump_s(c)+'/'+dump_s(len_)+'/'+dump_s(ofs_)
 return(sx)

def anal_runlist(s,nr):
 """
 s - ostatok iz atributa tipa 0000010, 
   napr., 31 05 13 F6 03 00 00 00;
 nr - dlq otladki.
31 05 13 F6-03 00 00 00
-> 
3 - size of offs. field
1 - size of length field
05 - length of run
13 F6 03 - offs. to starting LCN of prev. (?) el-t.
 """
 print 'anal_runlist:',dump_s_(s)
 pos=0
 cepocki=[]
 while True:
  c=s[pos]
  if ord(c)==0: break
  siz_ofs=ord(c)/16; siz_len=ord(c)%16        # W na[em primere - 3 i 1.
  len_=s[pos+1:pos+1+siz_len]                 # chr(05)
  ofs_=s[pos+1+siz_len:pos+1+siz_len+siz_ofs] # chr(13)+chr(F6)+chr(03)
  cepocka=(c,len_,ofs_)
  cepocki.append(cepocka)
  sx1=s_cepocka(cepocka)
  sx2 = '%04X %s' % (nr,sx1) 
  print sx2
  zapis_info(sx2)
  pos=pos+1+siz_len+siz_ofs      # Na na`alo sledu;]ej cepo`ki.
 fajl_parame['cepocki']=cepocki
  
def ust_time(imq,time_NTFS):
 """
 152_NTFS.zip ->
 The time values are given in 100 nanoseconds since 
 January 1, 1601, UTC.
 help(time) -> on Unix - generally January 1st, 1970.
 """
 time_=t_NTFS_1970(time_NTFS)
 os.utime(imq, (time_,time_))

def t_NTFS_1970(t_NTFS, otlad=False):
 """
 152_NTFS.zip ->
 The time values are given in 100 nanoseconds since 
 January 1, 1601, UTC.
 help(time) -> on Unix - generally January 1st, 1970.
 ~islo dnej raznosti najdeno na primerah (sm. test_tim.py).
 -> raznicu porqdka sekundy za s`. okrugl.
 """
 delta_sek = 134774.*24.*60.*60.
 t_sek_1601 = t_NTFS/1e7
 t_sek_1970 = t_sek_1601 - delta_sek
 if otlad:
  c=time.localtime(t_sek_1970)
  print 't_NTFS_1970 ->',c
 return(t_sek_1970)

# --------

if __name__=='__main__':
 xx=dir()
 for x in xx: print x
